# TwoFactorDevices

Welcome to your new gem! In this directory, you'll find the files you need to be able to package up your Ruby library into a gem. Put your Ruby code in the file `lib/two_factor_devices`. To experiment with that code, run `bin/console` for an interactive prompt.

TODO: Delete this and the text above, and describe your gem

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'two_factor_devices'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install two_factor_devices
    
## Initialization
Run install generator with class name of devices owner
    
    rails g two_factor_devices:install User
    
During installation gem asks you about email gateway generation, or you can run it later by

    rails g two_factor_devices:email_gateway MyProjectMailer
    
Add gem toutes mount to your project `config/routes.rb`

    mount TwoFactorDevices::Engine, at: '/2fa', as: 'two_factor_devices'
    
## Configuration
  `device_owner` - class name of deveices owner e.g. User, Admin, etc...
  
  `otp_base_secret` - base secret for otp codes generation. Uses only for device confirmation.
  For authentication better to use unique secret per user.
  
  `email_gateway` - name of class that provide send_otp(code, recipient) class method. Where code is code for send, recipient is email address.
  
  `phone_gateway` - name of class that provide send_otp(code, recipient) class method. Where code is code for send, recipient is phone number.
  
  `layout` - base layout for gem views.     
    
## Usage
Get all devices for user

    user.two_factor_devices
    
Get default device

    user.primary_two_factor_device
    
Send otp to device

    TwoFactorDevices::Gateway.send_otp(device, 'code')

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

For development you can use predefined Fake gateway - `TwoFactorDevices::Gateways::Fake` that print code to output.

## Contributing

Bug reports and pull requests are welcome on Gitlab.

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).
