lib = File.expand_path('lib', __dir__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)
require 'two_factor_devices/version'

Gem::Specification.new do |spec|
  spec.name          = 'two_factor_devices'
  spec.version       = TwoFactorDevices::VERSION
  spec.authors       = ['DK - Dmitrii Krupennikov']
  spec.email         = ['dk@fefelovgroup.com']

  spec.summary       = 'Ability to configure devices for OTP code transmission'
  spec.description   = 'Allow to configure devices for otp code transmission'
  spec.homepage      = 'https://gitlab.touchplus.ie/foss/two_factor_devices'
  spec.license       = 'MIT'

  # Prevent pushing this gem to RubyGems.org. To allow pushes either set the 'allowed_push_host'
  # to allow pushing to a single host or delete this section to allow pushing to any host.
  if spec.respond_to?(:metadata)
    spec.metadata['allowed_push_host'] = 'https://rubygems.org'

    spec.metadata['homepage_uri'] = spec.homepage
    spec.metadata['source_code_uri'] = 'https://gitlab.touchplus.ie/foss/two_factor_devices'
    spec.metadata['changelog_uri'] = 'https://gitlab.touchplus.ie/foss/two_factor_devices'
  else
    raise 'RubyGems 2.0 or newer is required to protect against ' \
      'public gem pushes.'
  end

  # Specify which files should be added to the gem when it is released.
  # The `git ls-files -z` loads the files in the RubyGem that have been added into git.
  spec.files = Dir.chdir(File.expand_path(__dir__)) do
    `git ls-files -z`.split("\x0").reject { |f| f.match(%r{^(test|spec|features)/}) }
  end
  spec.bindir        = 'exe'
  spec.executables   = spec.files.grep(%r{^exe/}) { |f| File.basename(f) }
  spec.require_paths = ['lib']
  spec.required_ruby_version = '>= 2.5'

  spec.add_runtime_dependency 'email_validator', '>= 2.2'
  spec.add_runtime_dependency 'rails', '>= 5.2'
  spec.add_runtime_dependency 'rotp', '>= 4.0.0'

  spec.add_development_dependency 'bundler', '~> 1.17'
  spec.add_development_dependency 'factory_bot_rails', '~> 6.1.0'
  spec.add_development_dependency 'rake', '~> 10.0'
  spec.add_development_dependency 'rspec-rails', '>= 3.0.1'
  spec.add_development_dependency 'rubocop', '~> 1.11'
  spec.add_development_dependency 'rubocop-rspec', '~> 2.2'
end
